# Notes khi phát triển tool

## Shell script

+ Đọc file từng dòng một:

when working with file that has 'no terminal newline', the last line is not read correctly
-> use `[ -n $line ]` as guided here: https://stackoverflow.com/a/12916758/11722995
     
+ Kiểm tra xem file có tồn tại không

```
#!/bin/bash
file=./file_to_check
if [ ! -e "$file" ]; then
    echo "File does not exist"
else 
    echo "File exists"
fi 
```

Tham khảo: https://stackoverflow.com/a/21164441/11722995
```
-b filename - Block special file
-c filename - Special character file
-d directoryname - Check for directory Existence
-e filename - Check for file existence, regardless of type (node, directory, socket, symlink, etc.)
-f filename - Check for regular file existence not a directory
-G filename - Check if file exists and is owned by effective group ID
-G filename set-group-id - True if file exists and is set-group-id
-k filename - Sticky bit
-L filename - Symbolic link
-O filename - True if file exists and is owned by the effective user id
-r filename - Check if file is a readable
-S filename - Check if file is socket
-s filename - Check if file is nonzero size
-u filename - Check if file set-user-id bit is set
-w filename - Check if file is writable
-x filename - Check if file is executable
```

## Docker/Docker Compose

### Monitoring:

+ Đếm số lượng containers đang chạy (`--status=running`):

```bash
docker compose ps --status=running | grep 'xjasonlyu/tun2socks' | wc -l

docker compose ps --status=running | grep 'packetshare/packetshare' | wc -l
```

Nếu muốn check số lượng containers đang dừng/bị lỗi, thay `--status=running` bằng `--status=exited`.
Tham khảo: [`docker compose ps`](https://docs.docker.com/reference/cli/docker/compose/ps/)

## Network

### iptables

+ Direction:
  + INPUT: packets coming from the network and going to your server.
  + OUTPUT: packets originating from your server and going to the network.
  + FORWARD: packets forwarded by your server, if/when it acts as a router between different networks.

+ String matching algorithms:
  + BM (focuses on performance) and 
  + KMP (focuses on correctness)

+ We use KMP for correctness, BM seems have a bug (not sure, just a random search)
    > Under 5.3.x, iptables -A OUTPUT -p tcp -m string --algo bm --string POST -j DROP does not drop outgoing packets containing "POST". This command was instead working as intended with 5.0.0.

    But in fact,  tun2socks container uses `iptables v1.8.9 (legacy)`, not related to the bug. For us, the performance is not the issue, so we stick with KMP.
    
### Proxy
